<template>
<div>
    <div class="row inbox-wrapper">
        <!-- left wrapper start -->
        <!-- left wrapper end -->
        <!-- middle wrapper start -->
        <div class="col-md-12 col-xl-12 middle-wrapper">
            <div class="row">
                <div class="col-md-12 grid-margin">
                    <div class="card rounded">
                        <div class="card-header">
                            <div class="d-flex align-items-center justify-content-between">
                                <div class="d-flex align-items-center">
                                    <div class="ml-2">
                                        <p>Data Inovasi Daerah</p>
                                        <p class="tx-11 text-muted">List Inovasi Daerah</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="card-body">
                            <div class="row align-items-center">
                                <div class="col-md-6 grid-margin">
                                <div class="form-inline">
                                    <label class="mr-2">Pencarian</label>
                                    <input
                                    type="text"
                                    placeholder="Ketikan pencarian disini"
                                    class="form-control"
                                    v-model="filter"
                                    />
                                </div>
                                </div>
                                <div class="col-md-6 grid-margin">
                                <div class="form-inline float-right">
                                    <label class="mr-2">Lihat</label>
                                    <select class="form-control" v-model="per_page">
                                    <option value="10">10</option>
                                    <option value="25">25</option>
                                    <option value="50">50</option>
                                    <option value="100">100</option>
                                    </select>
                                    <label class="ml-2">Entri</label>
                                </div>
                                </div>
                            </div>
                            <div class="row">
                                <div class="table-responsive col-md-12">
                                    <b-table
                                        id="data-table"
                                        responsive
                                        hover
                                        :filter="filter"
                                        :items="dataList"
                                        :fields="fields"
                                        :per-page="per_page"
                                        :current-page="current_page"
                                        :sort-by="sortBy"
                                        :sort-desc="sortDesc"
                                        @filtered="onFiltered"
                                        show-empty
                                        :busy="isBusy"
                                    >
                                        <template v-slot:table-busy>
                                            <div class="text-center text-danger my-2">
                                                <b-spinner class="align-middle"></b-spinner>
                                                <strong>Loading...</strong>
                                            </div>
                                        </template>


                                        <template v-slot:cell(index)="row">
                                                {{(row.index+1)+(per_page*(current_page-1))}}
                                        </template>

                                        <!-- <template v-slot:cell(status)="row">
                                                {{row.item.status}}
                                        </template> -->
                                        <template v-slot:cell(workshop)="row">
                                                <span v-if="row.item.workshop==='0'|| row.item.workshop===''">Tidak Ikut</span>
                                                <span v-if="row.item.workshop==='1'">Workshop I</span>
                                                <span v-if="row.item.workshop==='2'">Workshop II</span>
                                                <span v-if="row.item.workshop==='12'">Workshop I & II</span>
                                        </template>
                                        <template v-slot:cell(owner)="row">
                                                {{row.item}}
                                        </template>
                                        <template v-slot:cell(status)="row">
                                            <div v-if="(row.item.status=='pending')">
                                                 <button type="button" class="btn btn-secondary">
                                                    Data sudah lengkap dan siap diproses
                                                </button>
                                            </div>
                                            <div v-if="(row.item.status=='proses')">
                                                 <button type="button" class="btn btn-info">
                                                    Proses
                                                </button>
                                            </div>
                                            <div v-if="(row.item.status=='approve')">
                                                 <button type="button" class="btn btn-success">
                                                    Approve
                                                </button>
                                            </div>
                                            <div v-if="(row.item.status=='revisi')">
                                                 <button type="button" class="btn btn-warning">
                                                    Revisi
                                                </button>
                                            </div>
                                            <div v-if="(row.item.status=='draft')">
                                                 <button type="button" class="btn btn-danger">
                                                    Data Belum Lengkap
                                                </button>
                                            </div>
                                        </template>
                                        <template v-slot:cell(id)="row">
                                            <button type="button" @click.prevent="Finalisasi(row.item.id)" class="btn btn-success">
                                                Finalisasi
                                            </button>
                                        </template>
                                        <template v-slot:cell(nama_singkat)="row">
                                            <div v-if="(row.item.nama_singkat===null)">
                                                <i>&lt;Silakan Isi Data Inovasi&gt;</i>
                                            </div>
                                            <div v-if="(row.item.nama_singkat!=null)">
                                                {{ row.item.nama_singkat }}
                                            </div>
                                        </template>
                                        <template v-slot:cell(tahapan_inovasi_id)="row">
                                            <div class="form-check" v-for="(tahapan_inovasi,index) in tahapaninovasi" :key="index">
                                                <div v-if="tahapan_inovasi.id === row.item.tahapan_inovasi_id">
                                                    {{ tahapan_inovasi.name }}
                                                </div>
                                            </div>
                                        </template>
                                        <template v-slot:cell(actions)="row">
                                            <button type="button" class="btn btn-primary btn-icon" @click="preview(row.item)">
                                                <b-icon icon="eye-fill"></b-icon>
                                            </button>

                                        </template>
                                    </b-table>
                                </div>
                                <div class="col-md-12">
                                    <b-pagination
                                        v-model="current_page"
                                        :total-rows="total_rows"
                                        :per-page="per_page"
                                        align="right"
                                        aria-controls="data-table"
                                    ></b-pagination>
                                </div>
                            </div>
                        </div>
                        <!-- <div class="card-footer">
                            <button class="btn btn-primary mb-1 mb-md-0" type="submit" name="action" @click.prevent="addMatkul">Select
                                <i class="mdi mdi-send"></i>
                            </button>
                        </div> -->
                    </div>
                </div>
            </div>
        </div>
        <!-- middle wrapper end -->
        <!-- right wrapper start -->
        <!-- right wrapper end -->
    </div>

</div>
</template>

<script>

export default {
    components: {  },
    props:['datakrs'],
    data() {
         return {
            url:'getalldata',
            name:'table',
            emptyResult: false,
            dataList: [],
            totalSKS:0,
            current_page: 1,
            per_page: 10,
            filter: null,
            sortDesc: false,
            sortBy: "index",
            fields: [
                { key: "index", sortable: false, label: "#" },
                // { key: "innovator.nama", sortable: false, label: "Nama Inovator" },
                { key: "nama_singkat", sortable: false, label: "Nama Inovasi" },
                { key: "tahapan_inovasi_id", sortable: false, label: "Tahapan" },
                { key: "waktu_implementasi", sortable: false, label: "Waktu Penerapan" },
                { key: "status", sortable: false, label: "Status" },
                { key: "id", sortable: false, label: "Finalisasi" },
                { key: "actions", label: "Action" },
            ],
            total_rows: 0,
            dataBentrok : {},
            isBusy:true,
            json_fields: {
                'ID': 'id',
                'Fullname': 'innovator',
                'Institusi': 'institusi',
                'Telephone': 'phone',
                'Email': 'email',
                'Workshop' : {
                    field: 'workshop',
                    callback: (value) => {
                        if(value==='0' || ''){
                          return "Tidak Ikut";
                        }
                        if(value==='1'){
                          return "Workshop I";
                        }
                        if(value==='2'){
                          return "Workshop II";
                        }
                        if(value==='12'){
                          return "Workshop I & II";
                        }
                    }
                  },
                'Biaya Workshop': 'biaya_workshop',
                'Symposium': 'symposium',
                'Biaya Symposium': 'biaya_symposium',
                'Total': 'total',
                'Tanggal Konfirmasi': 'created_at'
                // 'Payment' : {
                //     field: 'payment',
                //     callback: (value) => {
                //         return (value===1)?"Sudah Bayar":"Belum Bayar";
                //     }
                //   },
            },
            json_meta: [
                [
                    {
                        'key': 'charset',
                        'value': 'utf-8'
                    }
                ]
            ],
            datainovasi:[],
            tahapaninovasi:[],
            finalisasiinovasi:[],
            check:0,
            inovasi:'<Silakan Isi Data Inovasi>',
            video:[],
        }

    },
    watch:{
        finalisasiinovasi:function(val){
            if (val!=0) {
                this.checkingData()
            }
        }
    },
    created(){
        this.initial()
        this.getTahapanInovasi()
        this.getDataInovasi()
    },
    methods:{
        initial(){
            this.getData()
        },
        async getData() {
            let self = this
            let ulrlist = `${this.url}`
            console.log(ulrlist)
            this.dataList = await axios.get(ulrlist).then((response)=> {
                this.isBusy = false
                return response.data
            })
            this.total_rows =  this.dataList.length
        },

        onFiltered(filteredItems) {
          // Trigger pagination to update the number of buttons/pages due to filtering
          this.total_rows = filteredItems.length;
          this.current_page = 1;
        },

        getTahapanInovasi() {
            let url = 'get/tahapaninovasi'
            axios.get(url).then(response => {
                this.tahapaninovasi = response.data
            })
        },

        getDataInovasi(){
            let url = 'getinovasi'
            axios.get(url).then(response => {
                this.datainovasi = response.data
                this.check=1
            })
        },

        //deleteinovasi
        remove(data){
            // console.log(data.id)
            Swal.fire({
            title: 'Apakah kamu yakin?',
            text: "Menghapus data inovasi!",
            icon: 'warning',
            showCancelButton: true,
            confirmButtonColor: '#3085d6',
            cancelButtonColor: '#d33',
            confirmButtonText: 'Iya, hapus!'
            }).then((result) => {
                if (result.isConfirmed) {
                    this.deleteInovasi(data.id)
                    this.getData()
                }
            })

        },
        async deleteInovasi(id){
            let url = `delete/datainovasi/${id}`
            // console.log(url)
            await axios.post(url).then(response => {
            })

        },
        todataInovasi(visit){
            let data = {
                visit
            }
            this.$emit('datacomponent', data)
        },

        //preview from vue table
        preview(data){
            this.toEdit('PreviewInovasi',data)
        },

        //edit from vue table
        edit(data){
            this.toEdit('AddInovasi',data)
        },

        toEdit(action,data){
            let dataEmit = {
                visit : action,
                data : data,
                back : this.component,
            }
            this.$emit('datacomponent', dataEmit)
        },


        //add innovation and kuisioner
        add(){
            // if (this.datainovasi==='') {
                this.toNextComponent('InovasiOpd')
            // }else{
                // this.toNextComponent('AddInovasi')
            // }
        },
        //function send to next component
        toNextComponent(visit){
            //kita combinasikan data form 1 dan form 2
            // let datamerged = Object.assign( {}, this.dataprops, this.currentData);
            let data = {
                back:this.component,
                data:this.datainovasi,
                visit
            }
            this.$emit('datacomponent', data)
        },

        Finalisasi(id){
            let url = `get/inovasi/${id}`
            axios.get(url).then(response => {
                this.finalisasiinovasi = response.data
            })
        },
        checkingData(){
             this.video = JSON.parse(this.finalisasiinovasi.linkvideos)
            if(
                this.finalisasiinovasi.nama_singkat != null &&
                this.finalisasiinovasi.nama_lengkap != null &&
                this.finalisasiinovasi.tahapan_inovasi_id != 1 &&
                this.finalisasiinovasi.inisiator_inovasi_id != 1 &&
                this.finalisasiinovasi.sistem_inovasi_id != 1 &&
                this.finalisasiinovasi.bentuk_inovasi_id != 1 &&
                this.finalisasiinovasi.jenis_inovasi_id != 1 &&
                this.finalisasiinovasi.covid_inovasi_id != 1 &&
                this.finalisasiinovasi.bidang_inovasi_id != 1 &&
                this.finalisasiinovasi.urusaninovasi.length != 0 &&
                this.finalisasiinovasi.waktu_ujicoba != null &&
                this.finalisasiinovasi.waktu_implementasi != null &&
                this.finalisasiinovasi.rancang_bangun != null &&
                this.finalisasiinovasi.tujuan != null &&
                this.finalisasiinovasi.manfaat != null &&
                this.finalisasiinovasi.hasil != null &&
                this.finalisasiinovasi.anggaran_inovasi_id != 1 &&
                this.finalisasiinovasi.ket_anggaran != null &&
                this.finalisasiinovasi.file_anggaran != null &&
                this.finalisasiinovasi.proses_inovasi_id != 1 &&
                this.finalisasiinovasi.ket_proses != null &&
                this.finalisasiinovasi.file_proses != null &&
                this.finalisasiinovasi.logo != null &&
                this.finalisasiinovasi.photos != null &&
                this.finalisasiinovasi.video_inovasi_id != 1 &&
                this.finalisasiinovasi.ket_vide != null &&
                this.video[0].link_video != null &&
                //kuisioner
                this.finalisasiinovasi.kuisioner.regulasi_inovasi_id != 1 &&
                this.finalisasiinovasi.kuisioner.regulasi_file != null &&
                this.finalisasiinovasi.kuisioner.regulasi_filename != null &&
                this.finalisasiinovasi.kuisioner.ketersediaan_sdm_id != 1 &&
                this.finalisasiinovasi.kuisioner.sdm_file != null &&
                this.finalisasiinovasi.kuisioner.sdm_filename != null &&
                this.finalisasiinovasi.kuisioner.dukungan_anggaran_id != 1 &&
                this.finalisasiinovasi.kuisioner.dukungananggaran_file != null &&
                this.finalisasiinovasi.kuisioner.anggaran_filename != null &&
                this.finalisasiinovasi.kuisioner.penggunaan_it_id != 1 &&
                this.finalisasiinovasi.kuisioner.it_file != null &&
                this.finalisasiinovasi.kuisioner.it_filename != null &&
                this.finalisasiinovasi.kuisioner.bimtek_id != 1 &&
                this.finalisasiinovasi.kuisioner.bimtek_file != null &&
                this.finalisasiinovasi.kuisioner.bimtek_filename != null &&
                this.finalisasiinovasi.kuisioner.program_renstra_id != 1 &&
                this.finalisasiinovasi.kuisioner.renstra_file != null &&
                this.finalisasiinovasi.kuisioner.renstra_filename != null &&
                this.finalisasiinovasi.kuisioner.keterlibatan_aktor_id != 1 &&
                this.finalisasiinovasi.kuisioner.keterlibatan_file != null &&
                this.finalisasiinovasi.kuisioner.keterlibatan_filename != null &&
                this.finalisasiinovasi.kuisioner.pelaksana_id != 1 &&
                this.finalisasiinovasi.kuisioner.pelaksana_file != null &&
                this.finalisasiinovasi.kuisioner.pelaksana_filename != null &&
                this.finalisasiinovasi.kuisioner.jejaring_inovasi_id != 1 &&
                this.finalisasiinovasi.kuisioner.jejaring_file != null &&
                this.finalisasiinovasi.kuisioner.jejaring_filename != null &&
                this.finalisasiinovasi.kuisioner.sosialisasi_id != 1 &&
                this.finalisasiinovasi.kuisioner.sosialisasi_file != null &&
                this.finalisasiinovasi.kuisioner.sosialisasi_filename != null &&
                this.finalisasiinovasi.kuisioner.pedoman_teknis_id != 1 &&
                this.finalisasiinovasi.kuisioner.pedoman_file != null &&
                this.finalisasiinovasi.kuisioner.pedoman_filename != null &&
                this.finalisasiinovasi.kuisioner.kemudahan_layanan_id != 1 &&
                this.finalisasiinovasi.kuisioner.layanan_file != null &&
                this.finalisasiinovasi.kuisioner.layanan_filename != null &&
                this.finalisasiinovasi.kuisioner.kemudahan_proses_id != 1 &&
                this.finalisasiinovasi.kuisioner.proses_file != null &&
                this.finalisasiinovasi.kuisioner.proses_filename != null &&
                this.finalisasiinovasi.kuisioner.layanan_pengaduan_id != 1 &&
                this.finalisasiinovasi.kuisioner.pengaduan_file != null &&
                this.finalisasiinovasi.kuisioner.pengaduan_filename != null &&
                this.finalisasiinovasi.kuisioner.online_sistem_id != 1 &&
                this.finalisasiinovasi.kuisioner.online_file != null &&
                this.finalisasiinovasi.kuisioner.online_filename != null &&
                this.finalisasiinovasi.kuisioner.replikasi_id != 1 &&
                this.finalisasiinovasi.kuisioner.replikasi_file != null &&
                this.finalisasiinovasi.kuisioner.replikasi_filename != null &&
                this.finalisasiinovasi.kuisioner.kecepatan_inovasi_id != 1 &&
                this.finalisasiinovasi.kuisioner.kecepatan_file != null &&
                this.finalisasiinovasi.kuisioner.kecepatan_filename != null &&
                this.finalisasiinovasi.kuisioner.kemanfaatan_inovasi_id != 1 &&
                this.finalisasiinovasi.kuisioner.kemanfaatan_file != null &&
                this.finalisasiinovasi.kuisioner.kemanfaatan_filename != null &&
                this.finalisasiinovasi.kuisioner.monitoring_id != 1 &&
                this.finalisasiinovasi.kuisioner.monitoring_file != null &&
                this.finalisasiinovasi.kuisioner.monitoring_filename != null
            ){
                Toast.success('Finalisasi Data Sukses!');
                this.updateFinalisasi();
            }else{
                Toast.warning('Tolong Cek Data Inovasi dan Kuisioner!');
            }
        },
        async updateFinalisasi(){
            let id = this.finalisasiinovasi.id
            let url = `update/finalisasi/${id}`
            await axios.post(url).then(response => {
            //    this.currentData.id = response.data
            })
        },
    }
}
</script>
<style>
</style
